//Copyright (c) 2000 QUARTIC Inc. [L NH[eBbN]
/*
ACeĂG
Ƃ肠TCgIȓ
*/
#include "XSP2lib.H"
#include "SPASSION.H"
#include "player.h"
#include "enemy.h"
#include "eshot.h"
#include "effect.h"
#include "priority.h"
#include "sound.h"
#include "entry.h"
#ifndef NULL
#define NULL ((void *) 0)
#endif

#define PALET_MAIN	0x0600

static short MoveEnemyBubble_L( ENEMY *ene );
/*static void TiniEnemyBubble_L(ENEMY *);*/
static short MoveEnemyBubble(ENEMY *);
/*static void TiniEnemyBubble(ENEMY *);*/

#define PT_ST_L		0x7
#define PT_END_L	0xA
#define PT_ST		0x13
#define PT_END		0x16

static HIT_XY4	hitl_p[]={-6-PLAYER_HIT_X,-6-PLAYER_HIT_Y,6+PLAYER_HIT_X,6+PLAYER_HIT_Y};
static HIT_XY4	hitl_o[]={-6-OPTION_HIT_X,-6-OPTION_HIT_Y,6+OPTION_HIT_X,6+OPTION_HIT_Y};
static HIT_XY4	hitl_s[]={-6,-6,6,6};

/* 16x16L̓蔻 */
extern HIT_XY4	hit8_p;
extern HIT_XY4	hit8_o;
extern HIT_XY4	hit8_s;
static unsigned char seed=0;

void InitEnemyBubble_LHit( void )
{
}
/* InitEnemyZako00HitƓȂ̂łȂ */
void InitEnemyBubbleHit( void )
{
}

void InitEnemyBubble_L(ENEMY *ene)
{
	short	pal[8]= {0x100,0x600,0x600,0x700,0x800,0xA00,0xB00,0xC00};

/*	ene->info		 = PALET_MAIN | PRIORITY_ZAKO;*/
	ene->info		 = pal[rndtable[seed++]&7] | PRIORITY_ZAKO;
	seed&=255;
	ene->vx			 = (ene->arg>>8          ) * 32768;		/* ̏ʃoCgvxɂ */
	ene->vy			 = ((char)(ene->arg&0xFF)) * 32768;		/* ̉ʃoCgvyɂ */
	ene->hit_p[0]	 = &hitl_p[0];ene->hit_p[1]=(HIT_XY4 *)NULL;
	ene->hit_o[0]	 = &hitl_o[0];ene->hit_o[1]=(HIT_XY4 *)NULL;
	ene->hit_s[0]	 = &hitl_s[0];ene->hit_s[1]=(HIT_XY4 *)NULL;
	ene->hp			 = 20;
	ene->no_dead	 = 1;
	ene->func_enemy_move = MoveEnemyBubble_L;
/*	ene->func_enemy_tini = TiniEnemyBubble_L;*/
}


void InitEnemyBubble(ENEMY *ene)
{
	int		pvx,pvy;

	/* x𗎂Ƃ */
	if( ene->parent->vx < 0 )
		pvx=ene->parent->vx*-1;
	else
		pvx=ene->parent->vx;
	if( ene->parent->vy < 0 )
		pvy=ene->parent->vy*-1;
	else
		pvy=ene->parent->vy;

	if( pvx>>16 < (ene->vx = (rndtable[seed++] & 0x3)) )
		ene->vx=ene->parent->vx/2;
	else
		ene->vx *= 32768;
	seed&=255;
	if( rndtable[seed++]>127 )
		ene->vx *= -1;
	seed&=255;

	/* x𗎂Ƃ */
	if( pvy>>16 < (ene->vy = (rndtable[seed++] & 0x3)) )
		ene->vy=ene->parent->vy/2;
	else
		ene->vy *= 32768;
	seed&=255;

	if( rndtable[seed++]>127 )
		ene->vy *= -1;
	seed&=255;

	ene->info		 = ene->arg;
	ene->hit_p[0]	 = &hit8_p;ene->hit_p[1]=(HIT_XY4 *)NULL;
	ene->hit_o[0]	 = &hit8_o;ene->hit_o[1]=(HIT_XY4 *)NULL;
	ene->hit_s[0]	 = &hit8_s;ene->hit_s[1]=(HIT_XY4 *)NULL;
	ene->hp			 = 10;
	ene->no_dead	 = 1;
	ene->func_enemy_move = MoveEnemyBubble;
/*	ene->func_enemy_tini = TiniEnemyBubble;*/
}


static short MoveEnemyBubble_L( ENEMY *ene )
{
/*	short	anim_num;*/

    /* x𑫂ďʃ[hiŒ萮jo */
	ene->x = ((ene->lx += ene->vx) >> 16);
	ene->y = ((ene->ly += ene->vy) >> 16);

	ene->pt = obj_obj_b+PT_ST_L+(ene->anim_count++)/8;
	if( ene->pt > obj_obj_b+PT_END_L ){
		ene->pt = obj_obj_b+PT_ST_L;
		ene->anim_count=0;
	}
#if 0
	if(ENE_X < 128){
		ene->lx = 128*65536;
		ene->ly = 128*65536;
		ene->vx = 0;
		ene->vy = 0;
	}
	if( BITSNS(0x04) & BIT(1) ){
		while( BITSNS(0x04) & BIT(1) );
		entry_counter_stop = 0;
		return (0);
	}
#endif
	/* ʊOɏo */
	if( ENE_X < 16 - 16 || ENE_X > 255 + 32 || ENE_Y < 16 - 16 || ENE_Y > 255 + 32 )
		return (0);

	/* _[W󂯂̏ */
#if 1
	if(ene->damage){
		if( ene->damage_kind!=PLAYER_ATTACK ){
			if((ene->hp -= ene->damage) <= 0) {
				SetSE(SE_EXPL_BUBBLE);	/*  */
				ene->player->score += 5;
				MakeEnemy(ENEMY_BUBBLE , ene->x  , ene->y, ene->info,  ene);	/* Aij */
				MakeEnemy(ENEMY_BUBBLE , ene->x  , ene->y, ene->info,  ene);	/* Aij */
				return (0);		/*  */
			}
		}else if( ene->player->state==PLAYER_ALIVE ){
			ene->player->x = ((ene->player->lx = ene->lx-(5<<16)) >> 16);
			ene->player->y = ((ene->player->ly = ene->ly        ) >> 16);
			ene->damage_kind=0;
		}
		ene->damage = 0;
	}
#endif

	xobj_set_st(ene);

	return(1);
}

static short MoveEnemyBubble( ENEMY *ene )
{
/*	short	anim_num;*/

    /* x𑫂ďʃ[hiŒ萮jo */
	ene->x = ((ene->lx += ene->vx) >> 16)-8;	/*-8͕\ʒu炷*/
	ene->y = ((ene->ly += ene->vy) >> 16)-8;

	ene->pt = obj_obj+PT_ST+(ene->anim_count++)/8;
	if( ene->pt > obj_obj+PT_END ){
		ene->pt = obj_obj+PT_ST;
		ene->anim_count=0;
	}
#if 0
	if(ENE_X < 128){
		ene->lx = 64*65536;
		ene->ly = 192*65536;
		ene->vx = 0;
		ene->vy = 0;
	}
	if( BITSNS(0x04) & BIT(1) ){
		while( BITSNS(0x04) & BIT(1) );
		entry_counter_stop = 0;
		return (0);
	}
#endif

	/* ʊOɏo */
	if( ENE_X < 16 - 8 || ENE_X > 255 + 24 || ENE_Y < 16 - 8 || ENE_Y > 255 + 24 )
		return (0);

	/* _[W󂯂̏ */
#if 1
	if(ene->damage){
		if((ene->hp -= ene->damage) <= 0) {
			SetSE(SE_EXPL_BUBBLE);	/*  */
			ene->player->score += 1;
			return (0);		/*  */
		}
		ene->damage = 0;
	}
#endif

	xsp_set_st(ene);

	return(1);
}

/*
static void TiniEnemyBubble(ENEMY * p)
{
}
*/
