//Copyright (c) 2000 QUARTIC Inc. [L NH[eBbN]
#include "effect.h"

#ifndef NULL
#define NULL ((void *) 0)
#endif

#define EFFECT_MAX	32	/* GtFNgő吔 */
static EFFECT effect[EFFECT_MAX];	/* [N */
static EFFECT *effect_top,	/* gp̃[ÑXg */
 *effect_null_top;		/* ̃[ÑXg */

typedef void (*func_init) (struct _effect *);
func_init FuncInitEffect[]=
{
	InitEffectExplL,
	InitEffectExpl,
	InitEffectExplMini,
	InitEffectExplPlayer,
	InitEffectHahen,
	InitEffectHahenMini,
	InitEffectTitSpark,

};


void InitEffect( void )
{
	int i;

    /* XgȂ */
	effect_top = (EFFECT *)NULL;
	effect_null_top = effect;
	for (i = 0; i < EFFECT_MAX; i++)
		effect[i].next = &effect[i + 1];

	effect[EFFECT_MAX - 1].next = (EFFECT *)NULL;
}


/* GtFNgoɌĂ΂ */
void MakeEffect(short type, short type2, short x, short y)
{
	EFFECT *p;

	if (effect_null_top == NULL)
		return;		/* 󂫂̃[NȂiLN^[I[o[j */

	p = effect_null_top;
	effect_null_top = p->next;
	p->next = effect_top;
	effect_top = p;

	p->type = type;
	p->type2 = type2;
	p->x = x;
	p->y = y;
	FuncInitEffect[type] (p);	/* [`֔ԁi֐ւ̃|C^ăcj */
}



/* ƂɌĂ΂ */
void MoveEffect( void )
{
	EFFECT *p, *q;

	p = effect_top;		/* ݒڂĂ郏[N */
	q = (EFFECT *)NULL;		/* PÕ[Ni[N폜ɕKvj */
	while (p != NULL) {
	    /* ړ[`֔ԁi֐ւ̃|C^ăcj */
		if( !(p->func_effect_move) (p) ) {	/* ԂlOȂ */
			if (q == NULL) {	/* Xg̈ԍŏ폜 */
				effect_top = p->next;
				p->next = effect_null_top;
				effect_null_top = p;
				q = (EFFECT *)NULL;
				p = effect_top;
			} else {
				q->next = p->next;
				p->next = effect_null_top;
				effect_null_top = p;
				p = q->next;
			}
		} else {
			q = p;
			p = p->next;
		}
	}
}



/* GtFNgɌĂ΂iʃNAj */
void EffectTini( void )
{
	int i;

    /* XgȂ */
	effect_top = (EFFECT *)NULL;
	effect_null_top = effect;
	for (i = 0; i < EFFECT_MAX; i++)
		effect[i].next = &effect[i + 1];

	effect[EFFECT_MAX - 1].next = (EFFECT *)NULL;
}
