//Copyright (c) 2000 QUARTIC Inc. [L NH[eBbN]
/* SPASSION.H */

/*#define DEBUG*/			/* fobO[h */

#define STAGES			4			/* ʐ */
#define SHOT_TYPES		2
#define POW_LEVELS		3
#define LASER_BUF_MAX	32
#define SPEED_MAX		32

#define MODE_1P		0
#define MODE_2P		1

/* Phbg̃JEg */
#define DOT_RATE	65536
#define BIT(i)		(1<<(i))
#define ON			1
#define OFF			0

#ifdef GLOBAL_DEFINE		/* O[oϐ̒`Ɛ錾Pɂ܂Ƃ߂eN */
#define Extern				/* Extern kɒu */
#else
#define Extern extern		/* Extern  extern ɒu */
#endif


/* O[oϐ */
Extern char		stage;		/* ʐiP=0j */
Extern short	level;		/* Փx */
Extern short	play_mode;	/* 1Play2Playi1Plaŷ݁j */
Extern short	game_state;

Extern short error_level;	/* ÑG[`FbN */
Extern char *error_message;

Extern unsigned char	angle_tbl[256][256];
Extern signed int vx_tbl[SPEED_MAX][256], vy_tbl[SPEED_MAX][256];
Extern short pt_rot[256];
Extern short info_rot[256];
Extern unsigned char rndtable[256];


Extern short obj_moji, obj_item, obj_player, obj_option, obj_shot, obj_shot_b,
             obj_zako, obj_zako_k, obj_hatch, obj_mine, obj_obj, obj_obj_b,
             obj_boss_m00, obj_boss_m01, obj_dragon,
             obj_boss1, obj_boss2, obj_boss3, obj_boss4, obj_lboss,
             obj_effect, obj_explall, obj_hahen, obj_titspark,obj_dummy,
			 obj_player1, obj_player2;

Extern int		map_x,map_y,map_vx,map_vy;
Extern short	map_width,map_height;
Extern unsigned short *bg_map[STAGES];
Extern unsigned char  bg_sp[STAGES][32 * 256];
Extern unsigned short bg_pal[STAGES][16];
Extern int		gr1_x,gr1_y,gr1_vx,gr1_vy,gr2_x,gr2_y,gr2_vx,gr2_vy;
Extern int		gr_x[2],gr_vx[2];
Extern short	bg_x,bg_y;

Extern char		disp_level;		/* \׃x */
Extern char		frm_disp;		/* t[[g\ */
Extern short	xsp_vsyncint_flag;


#ifdef DEBUG
Extern short eshot_sum;
Extern short enemy_sum;
#endif


enum {
	ERROR_NON = 0,		/* G[Ȃ */
	ERROR_FILE,			/* t@Cǂݍ߂Ȃ */
	ERROR_MUSIC,		/* y֌W */
	ERROR_DIRECTDRAW,	//DiretDraw֌W
};

enum {
	DISP_LEVEL_LOW = 0,	/* \ׂyڂ */
	DISP_LEVEL_MID,
	DISP_LEVEL_HIGH,
};

/* Փx */
enum { EASY = 0, NOMAL, HARD };

enum { IN_TITLE = 0,IN_GAME,IN_CONFIG,IN_GAME_END,IN_INIT_TITLE,
 IN_CHAR_SELECT,IN_GAME_START,IN_PAUSE,IN_STAGE_CLEAR,IN_GAME_OVER,
 IN_OPENING,IN_ENDING };

typedef struct HIT_XY4{
	signed short	x1,y1,x2,y2;
}HIT_XY4;

typedef struct HIT_XY{
	signed short	x,y;
}HIT_XY;

typedef struct BOX_PTR{
	short	x1;
	short	y1;
	short	x2;
	short	y2;
	unsigned short	color;
}BOX_PTR;
