//Copyright (c) 2000 QUARTIC Inc. [L NH[eBbN]
/* iA[U[Aދp */
#include "XSP2lib.H"
#include "SPASSION.H"
#include "player.h"
#include "enemy.h"
#include "eshot.h"
#include "effect.h"
#include "priority.h"
#include "sound.h"
#include "entry.h"
#include "SUB.H"
#ifndef NULL
#define NULL ((void *) 0)
#endif

#define P_X	(player[0].lx>>16)	/*lx̏ʃ[h*/
#define P_Y	(player[0].ly>>16)	/*ly̏ʃ[h*/

#define PALET_MAIN	0x0500

extern short	obj_boss_m01;
short enemy_explode( ENEMY *ene );
static short MoveEnemyBossM01(ENEMY *);
/*static void TiniEnemyBossM01(ENEMY *);*/

static HIT_XY4	hit_p[]={-10-PLAYER_HIT_X,-10-PLAYER_HIT_Y,10+PLAYER_HIT_X,10+PLAYER_HIT_Y};
static HIT_XY4	hit_o[]={-10-OPTION_HIT_X,-10-OPTION_HIT_Y,10+OPTION_HIT_X,10+OPTION_HIT_Y};
static HIT_XY4	hit_s[]={-10,-10,10,10};

void InitEnemyBossM01Hit( void )
{
}

void InitEnemyBossM01(ENEMY *ene)
{
	ene->angle		 = 192;
	ene->vx			 = vx_tbl[15][192];
	ene->vy			 = vy_tbl[15][192];
	ene->pt			 = obj_boss_m01 + ((ene->angle) >> 3);
	ene->info		 = PALET_MAIN | PRIORITY_ZAKO;
	ene->hit_p[0]	 = &hit_p[0];ene->hit_p[1]=(HIT_XY4 *)NULL;
	ene->hit_o[0]	 = &hit_o[0];ene->hit_o[1]=(HIT_XY4 *)NULL;
	ene->hit_s[0]	 = &hit_s[0];ene->hit_s[1]=(HIT_XY4 *)NULL;
	ene->hp			 = 20;
	ene->no_dead	 = 0;
	ene->func_enemy_move = MoveEnemyBossM01;
/*	ene->func_enemy_tini = TiniEnemyBossM01;*/
}


static short MoveEnemyBossM01( ENEMY *ene )
{
	unsigned char angle;
	short Wait( ENEMY *ene, short time );

	/* ĂQbɏi[U[ʂ̊Oɏô҂j */
	if( ene->dead_count ){
		if( ene->dead_count++ > 120 )
			return (0);		/*  */
		else
			return (1);
	}

    /* x𑫂ďʃ[hiŒ萮jo */
	ene->x = (ene->lx += ene->vx) >> 16;
	ene->y = (ene->ly += ene->vy) >> 16;
	ene->vx=vx_tbl[15][ene->angle];
	ene->vy=vy_tbl[15][ene->angle];

	switch (ene->state){
	case 0:
		/* ܂Ԃ */
		if( ENE_X < 192 ){
			if( ene->arg != 2 ){
				if( ENE_Y < 128+16 )
					ene->arg=1;
				else
					ene->arg=0;
			}
			ene->state++;
		}
		break;
	case 1:
		ene->vx=ene->vy=0;
		if( !Wait( ene, 120 ) ){
			if( ene->count==20 ){
				ESHOT	*eshot;
				switch ( level ){
				case EASY:
					/* [U[ */
					eshot=MakeEShot(ESHOT_LASER01, ENE_X, ENE_Y, 5, 128, 4,0,ene);
					eshot->box_x=-16-16;eshot->box_y=-16;
					SetSE(SE_LASER01);	/* GVbg */
					break;
				case NOMAL:
					/* [U[ */
					eshot=MakeEShot(ESHOT_LASEREX, ENE_Y, ENE_Y, 5, 128, 4,0,ene);
					eshot->box_x=-16-16;eshot->box_y=-16;
					SetSE(SE_EXLASER);	/* GVbg */
					break;
				case HARD:
					/* [U[ */
					eshot=MakeEShot(ESHOT_LASEREX, ENE_Y, ENE_Y, 5, 128, 4,0,ene);
					eshot->box_x=-16-16;eshot->box_y=-16;
					MakeEShot(ESHOT_ENG02, ENE_X, ENE_Y, 5, angle=calc_direction( ENE_X, ENE_Y, P_X+CENTER_X, P_Y ), 4,0,ene);
					MakeEShot(ESHOT_ENG02, ENE_X, ENE_Y, 5, (angle-12)&255, 4,0,ene);
					MakeEShot(ESHOT_ENG02, ENE_X, ENE_Y, 5, (angle+12)&255, 4,0,ene);
					SetSE(SE_EXLASER);	/* GVbg */
					break;
				}
			}
		}else
			ene->state++;
		break;
	case 2:
		if( ene->arg!=2 ){
			if( ene->arg )
				ene->angle-=2;
			else
				ene->angle+=2;

			ene->angle&=255;
			ene->pt   = obj_boss_m01 + ((ene->angle) >> 3);
			ene->info = PALET_MAIN | PRIORITY_ZAKO;
			if( ene->angle == 64 )
				ene->state++;
		}else
			ene->state++;
	case 3:
		/* ʊOɏo */
		if( ENE_X < 0 - 32 || ENE_X > 256 + 32 )
			ene->dead_count=1;
	}

	/* _[W󂯂̏ */
#if 1
	if(ene->damage){
		SetSE(SE_DAMAGE);	/* ʉ */
		ene->info = PALET_DAMAGE | PRIORITY_BOSS;	/*pbgύX*/
		/* j󂳂ꂽ */
		if((ene->hp -= ene->damage) <= 0) {
			MakeEffect(EFFECT_EXPL, 0, ene->x, ene->y);
			SetSE(SE_EXPL_MBOSS);	/*  */
			if(disp_level == DISP_LEVEL_HIGH)
				MakeEffect (EFFECT_HAHENMINI, 0, ene->x, ene->y);
			if(!eshot_erase)
				eshot_erase = ESHOT_ERASE;	/* e */
			ene->player->score += 3;
			ene->dead_count=1;
			ene->hit_p[0]=(HIT_XY4 *)NULL;
		}
		ene->damage = 0;
	}else
		ene->info = PALET_MAIN | PRIORITY_ZAKO;

#endif
#if 0
	if(ENE_X < 128){
		ene->lx = 127*65536;
		ene->ly = 224*65536;
		ene->vx = 0;
		ene->vy = 0;
		if( BITSNS(0x04) & BIT(1) ){		/* F */
			while( BITSNS(0x04) & BIT(1) );
			entry_counter_stop = 0;
			return (0);
		}
		ene->angle++;
		ene->angle&=255;
		ene->pt   = obj_boss_m01 + ((ene->angle) >> 3);
		ene->info = PALET_MAIN | PRIORITY_ZAKO;
	}
#endif
/*	ene->hit_p[0] = &hit_p[ene->anim_count];
	ene->hit_o[0] = &hit_o[ene->anim_count];
	ene->hit_s[0] = &hit_s[ene->anim_count];
*/
	xobj_set_st(ene);

	return(1);
}

/*
static void TiniEnemyBossM01(ENEMY * p)
{
	entry_control -= ENTRY_CONTROL_ADD;
}
*/
