//Copyright (c) 2000 QUARTIC Inc. [L NH[eBbN]
/*
NX^
*/
#include "XSP2lib.H"
#include "SPASSION.H"
#include "player.h"
#include "enemy.h"
#include "eshot.h"
#include "effect.h"
#include "priority.h"
#include "sound.h"
#include "entry.h"
#ifndef NULL
#define NULL ((void *) 0)
#endif

#define PALET_MAIN	0x0600

static short MoveEnemyCrystal_L( ENEMY *ene );
/*static void TiniEnemyCrystal_L(ENEMY *);*/
static short MoveEnemyCrystal_M( ENEMY *ene );
/*static void TiniEnemyCrystal_M(ENEMY *);*/
static short MoveEnemyCrystal(ENEMY *);
/*static void TiniEnemyCrystal(ENEMY *);*/

#define PT_ST_L		0x00
#define PT_END_L	0x02
#define PT_ST		0x10
#define PT_END		0x12

static HIT_XY4	hitl_p[]={-12-PLAYER_HIT_X,-12-PLAYER_HIT_Y,12+PLAYER_HIT_X,12+PLAYER_HIT_Y};
static HIT_XY4	hitl_o[]={-12-OPTION_HIT_X,-12-OPTION_HIT_Y,12+OPTION_HIT_X,12+OPTION_HIT_Y};
static HIT_XY4	hitl_s[]={-12,-12,12,12};

static HIT_XY4	hitm_p[]={-12-PLAYER_HIT_X,-12-PLAYER_HIT_Y,12+PLAYER_HIT_X,12+PLAYER_HIT_Y};
static HIT_XY4	hitm_o[]={-12-OPTION_HIT_X,-12-OPTION_HIT_Y,12+OPTION_HIT_X,12+OPTION_HIT_Y};
static HIT_XY4	hitm_s[]={-12,-12,12,12};

/* 16x16L̓蔻 */
extern HIT_XY4	hit8_p;
extern HIT_XY4	hit8_o;
extern HIT_XY4	hit8_s;
static unsigned char seed=0;

void InitEnemyCrystal_LHit( void )
{
}
void InitEnemyCrystal_MHit( void )
{
}
/* InitEnemyZako00HitƓȂ̂łȂ */
void InitEnemyCrystalHit( void )
{
}

void InitEnemyCrystal_L(ENEMY *ene)
{
	ene->info		 = PALET_MAIN | PRIORITY_ZAKO;
	ene->vx			 = (ene->arg>>8          ) * 32768;		/* ̏ʃoCgvxɂ */
	ene->vy			 = ((char)(ene->arg&0xFF)) * 32768;		/* ̉ʃoCgvyɂ */
	ene->hit_p[0]	 = &hitl_p[0];ene->hit_p[1]=(HIT_XY4 *)NULL;
	ene->hit_o[0]	 = &hitl_o[0];ene->hit_o[1]=(HIT_XY4 *)NULL;
	ene->hit_s[0]	 = &hitl_s[0];ene->hit_s[1]=(HIT_XY4 *)NULL;
	ene->hp			 = 20;
	ene->no_dead	 = 0;
	ene->func_enemy_move = MoveEnemyCrystal_L;
/*	ene->func_enemy_tini = TiniEnemyCrystal_L;*/

/*	entry_counter_stop = !0;*/		/* Gg[JE^[~ */
}


void InitEnemyCrystal_M(ENEMY *ene)
{
	/* O葬x𗎂Ƃ */
	if( ene->parent->vx>>16 > (ene->vx = -(rndtable[seed++] & 0x7)) )
		ene->vx=ene->parent->vx;
	else
		ene->vx *= 32768;
	seed&=255;

	if( ene->parent->vy>>16 > (ene->vy = -(rndtable[seed++] & 0x3)) )
		ene->vy=ene->parent->vy;
	else
		ene->vy *= 32768;
	seed&=255;

	if( rndtable[seed++]>127 )
		ene->vy *= -1;
	seed&=255;
	if( ene->vx > 0 )
		ene->vx *= -1;
	if( !ene->vx && !ene->vy )
		ene->vx = -65536/4;
/*printf("vx=%d vy=%d vx=%d vy=%d\n",ene->vx,ene->vy,ene->vx>>16,ene->vy>>16);
key_wait();
*/
	ene->info		 = PALET_MAIN | PRIORITY_ZAKO;
	ene->hit_p[0]	 = &hitm_p[0];ene->hit_p[1]=(HIT_XY4 *)NULL;
	ene->hit_o[0]	 = &hitm_o[0];ene->hit_o[1]=(HIT_XY4 *)NULL;
	ene->hit_s[0]	 = &hitm_s[0];ene->hit_s[1]=(HIT_XY4 *)NULL;
	ene->hp			 = 10;
	ene->no_dead	 = 0;
	ene->func_enemy_move = MoveEnemyCrystal_M;
/*	ene->func_enemy_tini = TiniEnemyCrystal_M;*/

/*	entry_counter_stop = !0;*/		/* Gg[JE^[~ */
}

void InitEnemyCrystal(ENEMY *ene)
{
	/* O葬x𗎂Ƃ */
	if( ene->parent->vx>>16 > (ene->vx = -(rndtable[seed++] & 0x7)) )
		ene->vx=ene->parent->vx;
	else
		ene->vx *= 32768;
	seed&=255;

	if( ene->parent->vy>>16 > (ene->vy = -(rndtable[seed++] & 0x3)) )
		ene->vy=ene->parent->vy;
	else
		ene->vy *= 32768;
	seed&=255;

	if( rndtable[seed++]>127 )
		ene->vy *= -1;
	seed&=255;
	if( ene->vx > 0 )
		ene->vx *= -1;
	if( !ene->vx && !ene->vy )
		ene->vx = -65536/4;

	ene->info		 = PALET_MAIN | PRIORITY_ZAKO;
	ene->hit_p[0]	 = &hit8_p;ene->hit_p[1]=(HIT_XY4 *)NULL;
	ene->hit_o[0]	 = &hit8_o;ene->hit_o[1]=(HIT_XY4 *)NULL;
	ene->hit_s[0]	 = &hit8_s;ene->hit_s[1]=(HIT_XY4 *)NULL;
	ene->hp			 = 5;
	ene->no_dead	 = 0;
	ene->func_enemy_move = MoveEnemyCrystal;
/*	ene->func_enemy_tini = TiniEnemyCrystal;*/

/*	entry_counter_stop = !0;*/		/* Gg[JE^[~ */
}


static short MoveEnemyCrystal_L( ENEMY *ene )
{
    /* x𑫂ďʃ[hiŒ萮jo */
	ene->x = ((ene->lx += ene->vx) >> 16);
	ene->y = ((ene->ly += ene->vy) >> 16);

	ene->pt = obj_obj_b+PT_ST_L+(ene->anim_count++)/8;
	if( ene->pt > obj_obj_b+PT_END_L ){
		ene->pt = obj_obj_b+PT_ST_L;
		ene->anim_count=0;
	}

#if 0
	if(ENE_X < 128){
		ene->lx = 192*65536;
		ene->ly = 192*65536;
		ene->vx = 0;
		ene->vy = 0;
	}
	if( BITSNS(0x04) & BIT(1) ){
		while( BITSNS(0x04) & BIT(1) );
		entry_counter_stop = 0;
		return (0);
	}
#endif

	/* ʊOɏo */
	if( ENE_X < 16 - 16 )
		return (0);

	/* _[W󂯂̏ */
#if 1
	if(ene->damage){
		SetSE(SE_DAMAGE);	/* ʉ */
		ene->info = PALET_DAMAGE | PRIORITY_BOSS;	/*pbgύX*/
		if((ene->hp -= ene->damage) <= 0) {
			SetSE(SE_EXPL_CRYSTAL);	/*  */
			ene->player->score += 5;
			MakeEnemy(ENEMY_CRYSTAL_M , ene->x  , ene->y, 0,  ene);	/* NX^ij */
			MakeEnemy(ENEMY_CRYSTAL_M , ene->x  , ene->y, 0,  ene);	/* NX^ij */
			return (0);		/*  */
		}
		ene->damage = 0;
	}else
		ene->info = PALET_MAIN | PRIORITY_ZAKO;
#endif

	xobj_set_st(ene);

	return(1);
}


static short MoveEnemyCrystal_M( ENEMY *ene )
{
	short	st=5,end=6;
	int		vx=0,vy=0;

    /* x𑫂ďʃ[hiŒ萮jo */
	ene->x = ((ene->lx += ene->vx) >> 16);
	ene->y = ((ene->ly += ene->vy) >> 16);

	if( ene->vx < 0 )
		vx = ene->vx*-1;
	if( ene->vy < 0 )
		vy = ene->vy*-1;

/*printf("0 st=%d,end=%d  \n",st,end);*/
	if( vx > vy ){
		st=5;end=6;
	}else{
		st=3;end=4;
	}
	ene->pt = obj_obj_b+st+(ene->anim_count++)/8;
	if( ene->pt > obj_obj_b+end ){
		ene->pt = obj_obj_b+st;
		ene->anim_count=0;
	}
/*
printf("1 st=%d,end=%d  \n",st,end);
key_wait();
*/
#if 0
	if(ENE_X < 128){
		ene->lx = 128*65536;
		ene->ly = 192*65536;
		ene->vx = 0;
		ene->vy = 0;
	}
	if( BITSNS(0x04) & BIT(1) ){
		while( BITSNS(0x04) & BIT(1) );
		entry_counter_stop = 0;
		return (0);
	}
#endif

	/* ʊOɏo */
	if( ENE_X < 16 - 16 )
		return (0);

	/* _[W󂯂̏ */
#if 1
	if(ene->damage){
		SetSE(SE_DAMAGE);	/* ʉ */
		ene->info = PALET_DAMAGE | PRIORITY_BOSS;	/*pbgύX*/
		if((ene->hp -= ene->damage) <= 0) {
			SetSE(SE_EXPL_CRYSTAL);	/*  */
			ene->player->score += 3;
			MakeEnemy(ENEMY_CRYSTAL , ene->x  , ene->y, 0,  ene);		/* NX^ij */
			MakeEnemy(ENEMY_CRYSTAL , ene->x  , ene->y, 0,  ene);		/* NX^ij */
			return (0);		/*  */
		}
		ene->damage = 0;
	}else
		ene->info = PALET_MAIN | PRIORITY_ZAKO;
#endif

	xobj_set_st(ene);

	return(1);
}

static short MoveEnemyCrystal( ENEMY *ene )
{
    /* x𑫂ďʃ[hiŒ萮jo */
	ene->x = ((ene->lx += ene->vx) >> 16)-8;	/*-8͕\ʒu炷*/
	ene->y = ((ene->ly += ene->vy) >> 16)-8;

	ene->pt = obj_obj+PT_ST+(ene->anim_count++)/8;
	if( ene->pt > obj_obj+PT_END ){
		ene->pt = obj_obj+PT_ST;
		ene->anim_count=0;
	}

#if 0
	if(ENE_X < 128){
		ene->lx = 64*65536;
		ene->ly = 192*65536;
		ene->vx = 0;
		ene->vy = 0;
	}
	if( BITSNS(0x04) & BIT(1) ){
		while( BITSNS(0x04) & BIT(1) );
		entry_counter_stop = 0;
		return (0);
	}
#endif

	/* ʊOɏo */
	if( ENE_X < 16 - 8 )
		return (0);

	/* _[W󂯂̏ */
#if 1
	if(ene->damage){
		SetSE(SE_DAMAGE);	/* ʉ */
		ene->info = PALET_DAMAGE | PRIORITY_BOSS;	/*pbgύX*/
		if((ene->hp -= ene->damage) <= 0) {
			SetSE(SE_EXPL_CRYSTAL_S);	/*  */
			ene->player->score += 1;
			return (0);		/*  */
		}
		ene->damage = 0;
	}else
		ene->info = PALET_MAIN | PRIORITY_ZAKO;
#endif

	xsp_set_st(ene);

	return(1);
}

/*
static void TiniEnemyCrystal(ENEMY * p)
{
}
*/
