//Copyright (c) 2000 QUARTIC Inc. [L NH[eBbN]
/* eshot.h */

#ifndef ESHOT_X
#define ESHOT_X	(eshot->lx>>16)		/*lx̏ʃ[h*/
#define ESHOT_Y	(eshot->ly>>16)		/*ly̏ʃ[h*/
#endif

#define ESHOT_ERASE	14	/* ep萔 */

typedef struct ESHOT{
	signed short x, y;				/* W */
	short	pt;						/* XvCgp^[mD */
	short	info;					/* ]R[hEFEDx\킷f[^ */
	signed int lx, ly;				/* 32bit X,Y W ( l = longword ) */
	signed int vx, vy;				/* x */
	short	*pt_;					/* XvCgp^[mDւ̃|C^ */
#if 0
	signed short hit_px, hit_py;	/* ΃vC[蔻 */
	signed short hit_ox, hit_oy;	/* ΃IvV蔻 */
#endif
	HIT_XY	*hit_p;					/* ΃vC[蔻 */
	HIT_XY	*hit_o;					/* ΃IvV蔻 */
	BOX_PTR	box,old_box;			/* [U[ȂǂɎg */
	signed short box_x, box_y;		/* box̊ɂȂW */

	short	type;					/* ̎ */
	short	arg;					/*  */
	short	state;					/* p */
	short	angle;					/* px (0~255) */
	unsigned char	 speed;			/* x (0~7) */
	short	flg;					/* etc */
	short	laser;					/* [U[nieLXggj */

	short	anim_count;				/* Aj[VJEg */
	short	count;					/* ėpJE^ */
	short (*func_eshot_move)( struct ESHOT * );	/* e̓p֐ */
	struct ENEMY *enemy;			/* ̒eGւ̃|C^ */
	struct ESHOT *next, *pre;		/* Xg */
}ESHOT;

/* GȅiMakeEShoẗj */
typedef struct ESHOTINFO{
	short	type;					/* G̎ */
	signed short x, y;				/* W */
	unsigned char speed;			/* x */
	unsigned char angle;			/* px */
	signed short t;					/*  */
	short	arg;					/*  */
	signed short box_x, box_y;		/* box̊ɂȂW */
	ENEMY	*enemy;					/* ˂Gւ̃|C^ */
}ESHOTINFO;


enum {
	ESHOT_ENG01 = 0,	/* GlM[eij */
	ESHOT_ENG02,		/* GlM[eij */
	ESHOT_ENG03,		/* GlM[eij */
	ESHOT_NOMAL,		/* ʏe */
	ESHOT_SYURIKEN,		/* 藠 */
	ESHOT_ENERGY01,		/* GlM[eij */
	ESHOT_ENERGY02,		/* GlM[eij */
	ESHOT_ENERGY03,		/* GlM[eij */
	ESHOT_RING01,		/* Oij */
	ESHOT_RING02,		/* Oij */
	ESHOT_LASER00,		/* [U[ */
	ESHOT_CUTTER,		/* Jb^[ */
	ESHOT_HOMING,		/* z[~O */
	ESHOT_PARACHUTE,	/* P */
	ESHOT_PARABOLA,		/*  */
	ESHOT_LASER01,		/* [U[ */
	ESHOT_LASEREX		/* Ƃ瑾Ȃ鉡[U[ */
};

#ifdef GLOBAL_DEFINE		/* O[oϐ̒`Ɛ錾Pɂ܂Ƃ߂eN */
#define Extern			/* Extern kɒu */
#else
#define Extern extern		/* Extern  extern ɒu */
#endif

Extern char eshot_erase;	/* >0 Ȃe */

/* ֐vg^Cv錾 */
void	InitEShot0( void );
void	InitEShot( void );
/*viod	MakeEShot(short type, signed short x, signed short y, unsigned char speed, unsigned char angle, signed short t, short arg, ENEMY *enemy);*/
/*ESHOT	*MakeEShot( ESHOTINFO * );*/
ESHOT	*MakeEShot(short type, signed short x, signed short y,
				   unsigned char speed, short angle,
				   signed short t, short arg, ENEMY *enemy);
void	MoveEShot( void );
ESHOT	*EraseEShot( ESHOT *eshot );
