//Copyright (c) 2000 QUARTIC Inc. [L NH[eBbN]
/* n */
#include "XSP2lib.H"
#include "SPASSION.H"
#include "player.h"
#include "enemy.h"
#include "eshot.h"
#include "effect.h"
#include "priority.h"
#include "sound.h"
#include "entry.h"
#ifndef NULL
#define NULL ((void *) 0)
#endif

#define PALET_MAIN1	0x0500
#define PALET_MAIN2	0x0300
#define PT_ST	0
#define PT_END	15

static short MoveEnemyMine(ENEMY *);
/*static void TiniEnemyMine(ENEMY *);*/

static HIT_XY4	hit_p[16];
static HIT_XY4	hit_o[16];
static HIT_XY4	hit_s[16]={
	-4,-4,4,4,  -6,-7, 6,7, -9,-9,9,9, -11,-12,11,12, -10,-11,10,11, -10,-11,10,11, -11,-11,11,11, -10,-11,10,11,
	-9,-9,9,9, -10,-9,10,9, -9,-9,9,9, -10, -9,10, 9,  -8, -8, 8, 8,  -6, -6, 6, 6, 999,999,999,999, 999,999,999,999
};

/* 16x16L̓蔻 */
extern HIT_XY4	hit8_p;
extern HIT_XY4	hit8_o;
extern HIT_XY4	hit8_s;

void InitEnemyMineHit( void )
{
	short	i;
	for(i=0;i<16;i++){
		hit_p[i].x1=hit_s[i].x1-PLAYER_HIT_X;hit_p[i].y1=hit_s[i].y1-PLAYER_HIT_Y;
		hit_p[i].x2=hit_s[i].x2+PLAYER_HIT_X;hit_p[i].y2=hit_s[i].y2+PLAYER_HIT_Y;
		hit_o[i].x1=hit_s[i].x1-OPTION_HIT_X;hit_o[i].y1=hit_s[i].y1-OPTION_HIT_Y;
		hit_o[i].x2=hit_s[i].x2+OPTION_HIT_X;hit_o[i].y2=hit_s[i].y2+OPTION_HIT_Y;
	}
}

void InitEnemyMine(ENEMY *ene)
{
	ene->pt			 = obj_obj+0xB;
	ene->info		 = PALET_MAIN1 | PRIORITY_ZAKO;
	ene->vx			 = -map_vx;
	ene->vy			 = 0;
	ene->hit_p[0]	 = &hit8_p;ene->hit_p[1]=(HIT_XY4 *)NULL;
	ene->hit_o[0]	 = &hit8_o;ene->hit_o[1]=(HIT_XY4 *)NULL;
	ene->hit_s[0]	 = &hit8_s;ene->hit_s[1]=(HIT_XY4 *)NULL;
	ene->hp			 = 5;
	ene->no_dead	 = 0;
	ene->func_enemy_move = MoveEnemyMine;
/*	ene->func_enemy_tini = TiniEnemyMine;*/

/*	entry_counter_stop = !0;*/		/* Gg[JE^[~ */
}


static short MoveEnemyMine( ENEMY *ene )
{
	short	anim_num;

	switch (ene->state){
	case 1:		/*  */
		anim_num=(ene->anim_count++)/16;
		ene->pt = obj_mine+anim_num;
		if( ene->pt > obj_mine+PT_END )
			return (0);		/*  */
		ene->hit_p[0] = &hit_p[anim_num];
		ene->hit_o[0] = &hit_o[anim_num];
		ene->hit_s[0] = &hit_s[anim_num];

	    /* x𑫂ďʃ[hiŒ萮jo */
		ene->x = ((ene->lx += ene->vx) >> 16);
		ene->y = ((ene->ly += ene->vy) >> 16);

		ene->damage = 0;
		xobj_set_st(ene);
		break;
	case 0:		/* ʏ */
	    /* x𑫂ďʃ[hiŒ萮jo */
		ene->x = ((ene->lx += ene->vx) >> 16)-8;	/*-8͕\ʒu炷*/
		ene->y = ((ene->ly += ene->vy) >> 16)-8;
		ene->pt = obj_obj+0xB+(ene->anim_count++)/4;
		if( ene->pt > obj_obj+0xC ){
			ene->pt = obj_obj+0xB;
			ene->anim_count=0;
		}
		/* _[W󂯂̏ */
		if(ene->damage){
			SetSE(SE_DAMAGE);	/* ʉ */
			ene->x += 8;
			ene->y += 8;
			ene->pt = obj_mine;
			ene->info = PALET_MAIN2 | PRIORITY_ZAKO;
			ene->state=1;
			SetSE(SE_EXPL_MINE);	/*  */
			ene->player->score += 1;
			ene->damage = 0;
			xobj_set_st(ene);
		}else
			xsp_set_st(ene);
		break;
	}

	/* ʊOɏo */
	if( ENE_X < 0 - 32 )
		return (0);

	return(1);
}

/*
static void TiniEnemyMine(ENEMY * p)
{
}
*/
