//Copyright (c) 2000 QUARTIC Inc. [L NH[eBbN]
// Shooting Passion

#include <windows.h>
#include <windowsx.h>
#include <ddraw.h>

#define GLOBAL_DEFINE		/* O[oϐmۂ */
#include "resource.H"
#include "DIRECTX.H"
#include "CONTROL.H"
#include "SPASSION.H"
#include "PLAYER.H"
#include "SHOT.H"
#include "SOUND.H"
#include "ENTRY.H"
#include "ENEMY.H"
#include "ESHOT.H"

#define APPNAME	"Shooting Passion"

#define CLIENTWIDTH		320
#define CLIENTHEIGHT	240
HWND	hWnd;
short	WinXmin=0,WinXmax=320;		//EBhE
short	WinYmax=240;				//EBhE
short	BPP=16;					//BPP

BOOL bActive = FALSE;

extern DDSURFACEDESC	ddsd_f,ddsd_sp,ddsd_z;	//T[tFCX
static short flag=0;

long FAR PASCAL WndProc( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch( message ){
	case WM_ACTIVATEAPP:
		bActive = (BOOL)wParam;
		if( bActive && lpDD && flag ){
			RestoreSurfaces();
			void	Disp( short mode );
			Disp( game_state );
		}
		break;
	case WM_CREATE:
//		if( !InitialApp( hWnd ) ){
//			DestroyWindow( hWnd );
//			return TRUE;
//		}
		bActive = TRUE;
		AppFont=CreateFont(
//			12,0,						//ύ
			12,5,						//ύ
			0,0,
			FW_NORMAL,					//̑
			FALSE,						//
			FALSE,						//
			FALSE,						//
			SHIFTJIS_CHARSET,			//g镶Zbg
			OUT_DEFAULT_PRECIS,			//
			CLIP_DEFAULT_PRECIS,		//
			NONANTIALIASED_QUALITY,		//
			VARIABLE_PITCH,				//
			"msgothic");				//
		break;
	case WM_SETCURSOR:
		SetCursor( FULLSCREEN?NULL:LoadCursor(NULL,IDC_ARROW) );
		SetCursor( NULL );
		return TRUE;
/*
	case WM_COMMAND:
		switch(wParam){
		case ID_DEVICE:
			bActive = FALSE;
			SetCursor( LoadCursor(NULL,IDC_ARROW) );
			if( !InitialApp( hWnd ) ){
				DestroyWindow( hWnd );
				return TRUE;
			}
			if( FULLSCREEN ) SetCursor( NULL );
			bActive = TRUE;
			break;
		}
		return TRUE;
*/
/*
	case WM_KEYDOWN:
		switch(wParam){
		case VK_ESCAPE:
			bActive = FALSE;
			SetCursor( LoadCursor(NULL,IDC_ARROW) );
			if( !InitialApp( hWnd ) ){
				DestroyWindow( hWnd );
				return TRUE;
			}
			if( FULLSCREEN ) SetCursor( NULL );
			bActive = TRUE;
			break;
		}
		return TRUE;
*/
	case WM_DESTROY:
		bActive = FALSE;
		ReleaseObjects();
		PostQuitMessage( 0 );
		break;
	case WM_MOVE:
		rcClient.left = LOWORD(lParam);
		rcClient.right = rcClient.left+CLIENTWIDTH;
		rcClient.top = HIWORD(lParam);
		rcClient.bottom = rcClient.top+CLIENTHEIGHT;
		break;
	}
	return DefWindowProc( hWnd, message, wParam, lParam );
}

int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
   LPSTR lpCmdLine, int nCmdShow )
{
	WNDCLASS wc;
	MSG msg;

	wc.style = CS_HREDRAW|CS_VREDRAW;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon( hInstance, MAKEINTRESOURCE(IDI_ICON1));
	wc.hCursor = LoadCursor( NULL, IDC_ARROW );
	wc.hbrBackground = GetStockBrush( BLACK_BRUSH );
	wc.lpszMenuName = APPNAME;
	wc.lpszClassName = APPNAME;

	RegisterClass( &wc );

	hAppInst = hInstance;

	// EBhENX̓o^
	hWnd = CreateWindowEx( WS_EX_APPWINDOW, APPNAME, APPNAME, 
//		WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX,
		WS_POPUP,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
		NULL, NULL, hInstance, NULL );
//	hWnd = CreateWindowEx(0,"Main Window",APPNAME,
//							WS_POPUP,
//							0,0,640,480,
//							(HWND)NULL,(HMENU)NULL,
//							hInstance,(LPSTR)NULL);
	if( !hWnd ) return FALSE;
	ShowWindow( hWnd, nCmdShow );
	UpdateWindow( hWnd );

	if( !InitialApp( hWnd ) ){
		ReleaseObjects();
		if( error_level != ERROR_NON ){
			MessageBox(NULL, error_message, "Error", MB_OK);
		}
		DestroyWindow( hWnd );
		return TRUE;
	}
	flag=1;
	// bZ[W|v
	while( TRUE ){
		if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) ){
			if( !GetMessage( &msg, NULL, 0, 0 ) ){
				return msg.wParam;
			}
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
		if( bActive ){
			short	GameMain( void );
			if( !GameMain() ){
				DestroyWindow( hWnd );
			}
		}
	}
}
void game_end( void )
{
	ReleaseObjects();
	if( error_level != ERROR_NON ){
		MessageBox(NULL, error_message, "Error", MB_OK);
	}
	DestroyWindow( hWnd );
}

// NCAgTCYɂ킹ăEBhETCY
void ResizeClientToFit( HWND hWnd )
{
	RECT wrect, crect;
	GetWindowRect( hWnd, &wrect );
	GetClientRect( hWnd, &crect );
	wrect.right += CLIENTWIDTH-(crect.right-crect.left);
	wrect.bottom += CLIENTHEIGHT-(crect.bottom-crect.top);
	MoveWindow( hWnd, wrect.left, wrect.top, wrect.right-wrect.left, wrect.bottom-wrect.top, TRUE );

	rcRect.left = rcRect.top = 0;
	rcRect.right = CLIENTWIDTH;
	rcRect.bottom = CLIENTHEIGHT;
	POINT point = { 0, 0 };
	ClientToScreen( hWnd, &point );
	rcClient.left = point.x;
	rcClient.right = CLIENTWIDTH+point.x;
	rcClient.top = point.y;
	rcClient.bottom = CLIENTHEIGHT+point.y;
}
