//Copyright (c) 2000 QUARTIC Inc. [L NH[eBbN]
/*
 *		XvCg̏ݒ
 */
#include <string.h>
#include "XSP2lib.H"
#include "SPASSION.H"
#include "SUB.H"

#define PCG_MAX		4096		/* XvCgobfp^[őgp */
#define FRM_MAX		16192		/* XvCgt[f[^őgp */
#define REF_MAX		2048		/* XvCgt@Xf[^őgp */

#define PAL_MAX		15			/* XvCgpbgp^[őgp */

static char pcg_alt[PCG_MAX + 1];				/* obfzuǗe[u */
static char pcg_dat[PCG_MAX * 128];				/* obff[^t@Cǂݍ݃obt@ */
static XOBJ_REF_DAT ref_dat[REF_MAX];			/* t@Xf[^ */
static XOBJ_FRM_DAT frm_dat[FRM_MAX];			/* t[f[^ */

static int sizeof_pcg = 0;	/* XvCgobfp^[ǂݍݐ */
static int sizeof_ref = 0;	/* XvCgt@Xf[^ǂݍݐ */
static int sizeof_frm = 0;	/* XvCgt[f[^ǂݍݐ */
short LoadSP( char *fname );

/* XSP ef[^ǂݍ */
static short LoadXSP (char *fname)
{
	int i;
	int f, r,pcg_num;
	short obj_no = sizeof_ref;
	char temp_fname[92];

	strcpy (temp_fname, fname);
	strcat (temp_fname, ".FRM");
	f = LoadFile (temp_fname, &frm_dat[sizeof_frm], sizeof (XOBJ_FRM_DAT), FRM_MAX - sizeof_frm);
	for(i=0;i<f;i++){
		unsigned short tmp1,tmp2;
		tmp1=(frm_dat[sizeof_frm+i].vx>>8)&0x00FF;
		tmp2=(frm_dat[sizeof_frm+i].vx<<8)&0xFF00;
		frm_dat[sizeof_frm+i].vx=tmp1|tmp2;
		tmp1=(frm_dat[sizeof_frm+i].vy>>8)&0x00FF;
		tmp2=(frm_dat[sizeof_frm+i].vy<<8)&0xFF00;
		frm_dat[sizeof_frm+i].vy=tmp1|tmp2;
		tmp1=frm_dat[sizeof_frm+i].pt>>8;
		tmp2=frm_dat[sizeof_frm+i].pt<<8;
		frm_dat[sizeof_frm+i].pt=tmp1|tmp2;
		tmp1=frm_dat[sizeof_frm+i].rv>>8;
		tmp2=frm_dat[sizeof_frm+i].rv<<8;
		frm_dat[sizeof_frm+i].rv=tmp1|tmp2;
	}

typedef	struct REF_TEMP{
	short	num;			/* XvCg */
//	void	*ptr;			/* Jnʒuւ̃|C^[ */
	unsigned char	ptr1;
	unsigned char	ptr2;
	unsigned char	ptr3;
	unsigned char	ptr4;
	short	unused;			/*igpj*/
}REF_TEMP;
REF_TEMP tmp_dat[REF_MAX];			/* t@Xf[^ */
	strcpy (temp_fname, fname);
	strcat (temp_fname, ".REF");
//	r = LoadFile (temp_fname, (void *)&ref_dat[sizeof_ref], sizeof (XOBJ_REF_DAT), REF_MAX - sizeof_ref);
	r = LoadFile (temp_fname, &tmp_dat[0], sizeof(REF_TEMP), REF_MAX - sizeof_ref);
	for(i=0;i<r;i++){
		ref_dat[sizeof_ref+i].num=tmp_dat[i].num;
		ref_dat[sizeof_ref+i].unused=tmp_dat[i].unused;

		unsigned short tmp1_,tmp2_;
		tmp1_=ref_dat[sizeof_ref+i].num>>8;
		tmp2_=ref_dat[sizeof_ref+i].num<<8;
		ref_dat[sizeof_ref+i].num=tmp1_|tmp2_;

		unsigned int tmp1,tmp2,tmp3,tmp4;
/*		tmp1=((int)ref_dat[sizeof_ref+i].ptr>>24)&0x000000FF;
		tmp2=((int)ref_dat[sizeof_ref+i].ptr>> 8)&0x0000FF00;
		tmp3=((int)ref_dat[sizeof_ref+i].ptr<< 8)&0x00FF0000;
		tmp4=((int)ref_dat[sizeof_ref+i].ptr<<24)&0xFF000000;
*/
		tmp1=tmp_dat[i].ptr4;tmp1=(tmp1<<24)&0xFF000000;
		tmp2=tmp_dat[i].ptr3;tmp2=(tmp2<<16)&0x00FF0000;
		tmp3=tmp_dat[i].ptr2;tmp3=(tmp3<<8 )&0x0000FF00;
		tmp4=tmp_dat[i].ptr1;
		ref_dat[sizeof_ref+i].ptr=(void *)(tmp1|tmp2|tmp3|tmp4);
	}
	strcpy (temp_fname, fname);
	pcg_num = LoadSP(temp_fname);
//	p = LoadFile (temp_fname, &pcg_dat[sizeof_pcg], sizeof (char), 128 * PCG_MAX - sizeof_pcg);

	/* FRM_DAT[].pt ␳ */
	for (i = 0; i < f; i++){
//		frm_dat[sizeof_frm + i].pt += sizeof_pcg / 128;
		frm_dat[sizeof_frm + i].pt += pcg_num;
	}

	/* REF_DAT[].ptr ␳ */
	for (i = 0; i < r; i++){
//		(int)ref_dat[sizeof_ref + i].ptr += (int)(&frm_dat[sizeof_frm]);
		int ptr=(int)ref_dat[sizeof_ref + i].ptr;

		unsigned int tmp1,tmp2,tmp3,tmp4;
		tmp1=(ptr>>24)&0x000000FF;
		tmp2=(ptr>> 8)&0x0000FF00;
		tmp3=(ptr<< 8)&0x00FF0000;
		tmp4=(ptr<<24)&0xFF000000;
		ptr=tmp1|tmp2|tmp3|tmp4;

		ptr+=(int)(&frm_dat[sizeof_frm]);
		ref_dat[sizeof_ref + i].ptr = (void *)ptr;
	}
//	sizeof_pcg += p;
	sizeof_frm += f;
	sizeof_ref += r;

#ifdef DEBUG
	printf ("%s ǂݍ݂܂ sizeof_ref = %hd\n", fname, obj_no);
#endif

	return (obj_no);
}

/* XvCgf[^̓ǂݍ݁Aݒ */
void LoadXSPFile( void )
{
	int		size=0;
	sizeof_pcg = 0;
	sizeof_ref = 0;
	sizeof_frm = 0;
	obj_boss1	= LoadXSP("SP/BOSS01");
	obj_boss2	= LoadXSP("SP/BOSS02");
	obj_boss3	= LoadXSP("SP/BOSS03");
	obj_boss4	= LoadXSP("SP/BOSS04");
	obj_boss_m00= LoadXSP("SP/BOSS_M00");
	obj_boss_m01= LoadXSP("SP/BOSS_M01");
	obj_dragon	= LoadXSP("SP/DRAGON");
	obj_effect	=  LoadSP("SP/EFFECT");
	obj_explall	= LoadXSP("SP/EXPLALL");
	obj_hahen	= LoadXSP("SP/HAHEN");
	obj_hatch	= LoadXSP("SP/HATCH");
	obj_item	=  LoadSP("SP/ITEM");
	obj_lboss	= LoadXSP("SP/LBOSS");
	obj_mine	= LoadXSP("SP/MINE");
	obj_moji	=  LoadSP("SP/MOJI");
	obj_obj		=  LoadSP("SP/OBJ");
	obj_obj_b	= LoadXSP("SP/OBJ_B");
	obj_option	=  LoadSP("SP/OPTION");
	obj_player1	= LoadXSP("SP/PLAYER");
	obj_player2	= LoadXSP("SP/BUTA");
	obj_shot	=  LoadSP("SP/SHOT");
	obj_shot_b	= LoadXSP("SP/SHOT_B");
	obj_dummy	= LoadXSP("SP/DUMMY");

	obj_titspark= LoadXSP("SP/TITSPARK");
	obj_zako	=  LoadSP("SP/ZAKO");
	obj_zako_k	=  LoadSP("SP/ZAKO_K");
	obj_player	= obj_player1;
}

/*----------------[ wroVXe ]----------------*/
void InitXSP( void )
{
	int		i=0;

	xsp_on() ;						/* wroVXegݍ */

//	xsp_pcgdat_set( pcg_dat			/* obff[^w */
//				  , pcg_alt			/* obfzuǗe[uw */
//				  , sizeof(pcg_alt)	/* obfzuǗe[ũTCYw */
//				  ) ;

	xsp_objdat_set( ref_dat ) ;		/* XvCg`f[^w */
}
