//Copyright (c) 2000 QUARTIC Inc. [L NH[eBbN]
/* nʂ */
#include "XSP2lib.H"
#include "SPASSION.H"
#include "player.h"
#include "enemy.h"
#include "eshot.h"
#include "effect.h"
#include "priority.h"
#include "BG.H"
#include "sound.h"
#include "entry.h"
#include "SUB.H"
#ifndef NULL
#define NULL ((void *) 0)
#endif

#define P_X	(player[0].lx>>16)	/*lx̏ʃ[h*/
#define P_Y	(player[0].ly>>16)	/*ly̏ʃ[h*/

#define PALET_MAIN	0x0500

short enemy_explode( ENEMY *ene );
static short MoveEnemyZako02(ENEMY *);
/*static void TiniEnemyZako02(ENEMY *);*/

#define PT_ST	0x18
#define PT_END	0x18+7

static HIT_XY4	hit_p[]={
	-8,-2,8,8,
	-8,-2,8,8,
	-8,-2,8,8,
	-8,-2,8,8,
	-8,-2,8,8,
	-8,-4,8,8,
	-8,-7,8,8,
	-8,-8,8,8
};
static HIT_XY4	hit_o[]={
	-8,-2,8,8,
	-8,-2,8,8,
	-8,-2,8,8,
	-8,-2,8,8,
	-8,-2,8,8,
	-8,-4,8,8,
	-8,-7,8,8,
	-8,-8,8,8
};
static HIT_XY4	hit_s[]={
	-8,-2,8,8,
	-8,-2,8,8,
	-8,-2,8,8,
	-8,-2,8,8,
	-8,-2,8,8,
	-8,-4,8,8,
	-8,-7,8,8,
	-8,-8,8,8
};

void InitEnemyZako02Hit( void )
{
	short	i;
	for(i=1;i<8;i++){
		hit_p[i].x1-=PLAYER_HIT_X;hit_p[i].y1-=PLAYER_HIT_Y;
		hit_p[i].x2+=PLAYER_HIT_X;hit_p[i].y2+=PLAYER_HIT_Y;
		hit_o[i].x1-=OPTION_HIT_X;hit_o[i].y1-=OPTION_HIT_Y;
		hit_o[i].x2+=OPTION_HIT_X;hit_o[i].y2+=OPTION_HIT_Y;
	}
}

void InitEnemyZako02(ENEMY *ene)
{
	ene->info		 = PALET_MAIN | PRIORITY_ZAKO;
	ene->vx			 = 0-map_vx;
	ene->vy			 = 0;
	ene->hit_p[0]	 = &hit_p[0];ene->hit_p[1]=(HIT_XY4 *)NULL;
	ene->hit_o[0]	 = &hit_o[0];ene->hit_o[1]=(HIT_XY4 *)NULL;
	ene->hit_s[0]	 = &hit_s[0];ene->hit_s[1]=(HIT_XY4 *)NULL;
	ene->hp			 = 1;
	ene->no_dead	 = 0;
	ene->func_enemy_move = MoveEnemyZako02;
/*	ene->func_enemy_tini = TiniEnemyZako02;*/

/*	entry_counter_stop = !0;*/		/* Gg[JE^[~ */
}


static short MoveEnemyZako02( ENEMY *ene )
{
	short	anim_num=0;
	unsigned char angle;

    /* x𑫂ďʃ[hiŒ萮jo */
	ene->x = ((ene->lx += ene->vx) >> 16)-8;	/*-8͕\ʒu炷*/
	ene->y = ((ene->ly += ene->vy) >> 16)-8;

	switch (ene->state){
	case 0:			/* ] */
		anim_num=(ene->anim_count++)/4;
		ene->pt = obj_zako+PT_ST+anim_num;
		if( anim_num > 4 ){
			if( player[0].lx > ene->lx )	/* vC[̕ɃWv */
				ene->vx= 1*65536-map_vx;
			else
				ene->vx=-1*65536-map_vx;
			ene->vy=-2*65536;
			ene->state++;
		}
		break;
	case 1:			/* Wv */
		ene->vy+=4096;
		if( ene->vy > 2*65536 )
			ene->vy = 2*65536;
		else if( ene->vy > 0 && ene->vy <= 4096 ){
			switch ( level ){
			case NOMAL:
				MakeEShot(ESHOT_ENG01, ENE_X, ENE_Y, 5, calc_direction( ENE_X, ENE_Y, P_X+CENTER_X, P_Y ), 4,0,ene);
				SetSE(SE_ESHOT_NOMAL);	/* GVbg */
				break;
			case HARD:
				MakeEShot(ESHOT_NOMAL, ENE_X, ENE_Y, 5, angle=calc_direction( ENE_X, ENE_Y, P_X+CENTER_X, P_Y ), 4,0,ene);
				MakeEShot(ESHOT_NOMAL, ENE_X, ENE_Y, 5, (angle-12)&255, 4,0,ene);
				MakeEShot(ESHOT_NOMAL, ENE_X, ENE_Y, 5, (angle+12)&255, 4,0,ene);
				SetSE(SE_ESHOT_NOMAL);	/* GVbg */
				break;
			}
		}
		if( ene->pt < obj_zako+PT_END ){
			anim_num=(ene->anim_count++)/4;
			ene->pt = obj_zako+PT_ST+anim_num;
		}else
			anim_num=7;		/* p^[̍Ō */
		/* wiafƂ̓蔻 */
		/* ɂԂ */
		if( (CheckBGHit(ene->x-16+ 0,ene->y-16+ 0)==GROUND_BG)			/**/
		 && (CheckBGHit(ene->x-16+15,ene->y-16+ 0)==GROUND_BG) ){		/*E*/
			ene->ly=( ((ene->y-16)/8+1)*8+8+16 )*65536;
			ene->vy=0;
		}
		/* ɂԂ */
		if( (CheckBGHit(ene->x-16+ 0,ene->y-16+15)==GROUND_BG)			/**/
		 && (CheckBGHit(ene->x-16+15,ene->y-16+15)==GROUND_BG) ){		/*E*/
			ene->ly=( ((ene->y-1)/8)*8-8+16 )*65536;
			ene->vy=0;
			ene->vx=0-map_vx;
			ene->state=2;	/* n */
			ene->anim_count=0;
		}
		/* ɂԂ */
		if( (CheckBGHit(ene->x-16+ 0,ene->y-16+ 0)==GROUND_BG)			/**/
		 && (CheckBGHit(ene->x-16+ 0,ene->y-16+15)==GROUND_BG) ){		/**/
			ene->lx=( ((ene->x-16)/8+1)*8+8+16 )*65536;
			ene->vx=0-map_vx;
		}
		/* EɂԂ */
		if( (CheckBGHit(ene->x-16+15,ene->y-16+ 0)==GROUND_BG)			/*E*/
		 && (CheckBGHit(ene->x-16+15,ene->y-16+15)==GROUND_BG) ){		/*E*/
			ene->lx=( ((ene->x-1)/8)*8-8+16 )*65536;
			ene->vx=0-map_vx;
		}
		break;
	case 2:			/* n */
		anim_num=(ene->anim_count++)/4;
		ene->pt = obj_zako+PT_END-anim_num;
		if( ene->pt < obj_zako+PT_ST ){
			ene->pt = obj_zako+PT_ST;
			ene->anim_count=0;
			ene->state=0;
		}
	}

	/* ʊOɏo */
	if( ENE_X < 0 + 16 - 8 || ENE_X > 255 + 24 || ENE_Y > 255 + 24 )
		return (0);

	/* _[W󂯂̏ */
	if(ene->damage){
		MakeEffect(EFFECT_EXPLMINI, 0, ene->x, ene->y);
		SetSE(SE_EXPL_S);	/*  */
		ene->player->score += 1;
		return (0);		/*  */
	}
	ene->hit_p[0] = &hit_p[anim_num];
	ene->hit_o[0] = &hit_o[anim_num];
	ene->hit_s[0] = &hit_s[anim_num];
	xsp_set_st(ene);

	return(1);
}

/*
static void TiniEnemyZako02(ENEMY * p)
{
}
*/
